/*************************************
 CacheMate REM sleep utility 0.1.0
 (C) JAN 2008 Hynek Sladky
 sladky@mujmail.cz
*************************************/
#include <PalmOS.h>
// ------------------------------------
// Handspring/Treo specific includes
// ------------------------------------
#include <PmSysGadgetLib.h>
#include <PmSysGadgetLibCommon.h>
#include <HsCreators.h>
#include <HsChars.h>
#include <HsKeyCodes.h>
#include <HsExt.h>
#include <HsKeyTypes.h>
#include <HsPhone.h>
#include <TonesLibTypes.h>
#include <TonesLib.h>
// ------------------------------------
// resources header
// ------------------------------------
#include "CM_sleepR.h"
#include "version.h"
extern const char *build, *build_date, *build_time;
// ------------------------------------
// defines
// ------------------------------------
#define AppID   'CMsl'
/******** ToDo ********/
/**********************
***********************/
// ====================================
// DEBUG functions
// ------------------------------------
// UI debug window
// ------------------------------------
#include <stdarg.h>
static void DEBUG (char *a, ...) {
char *b = MemPtrNew(256);
va_list p;
  va_start(p, a);
  StrVPrintF(b, a, p);
  FrmCustomAlert (show, b, "", "");
  va_end(p);
  MemPtrFree(b);
}
// ====================================
// global variables
// ------------------------------------
// preferences
// ------------------------------------
#define CMsleep_ON      0x0001
typedef struct {
  UInt32 bits;
} PrefsType;
PrefsType gPrefs;
// ====================================
// main form handler
// ------------------------------------    
static Boolean MainFormHandler (EventPtr event) {
FormPtr         frm;
Boolean         handled;

  frm = FrmGetActiveForm ();
  handled=false;
  switch (event->eType) {
    case frmOpenEvent:
      CtlSetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, CMs_enabled)), (gPrefs.bits & CMsleep_ON)!=0);
    case frmUpdateEvent:
      FrmDrawForm (frm);
      break;
    case ctlSelectEvent:
      switch (event->data.ctlSelect.controlID) {
        case CMs_enabled:
          gPrefs.bits=0;
          if (CtlGetValue (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, CMs_enabled)))) gPrefs.bits|=CMsleep_ON;
          break;
	default:
	  break;
      }
      break;
    case menuEvent:
      //handled=true;
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
        case menu_about:
          handled=true;
          if (FrmCustomAlert (alert_about, build, build_date, build_time)==1)
            FrmHelp (str_about);
          break;
	default:
	  //handled=false;
	  break;
      }
      break;
    default:
      break;
  }
  return handled;
}
// ====================================
// basic application functions
// ------------------------------------    
// startup setup
// ------------------------------------
static Err StartApplication(void) {
UInt16          size;

  MemSet (&gPrefs, sizeof (gPrefs), 0);
  size=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &size, true)!=noPreferenceFound) {
    if (size >sizeof (gPrefs)) size=sizeof (gPrefs);
    PrefGetAppPreferences (AppID, 0, &gPrefs, &size, true);
  }
  return 0;
}
// ------------------------------------
// exit cleanup
// ------------------------------------
static void StopApplication (Err code) {
UInt16          card;
LocalID         loc;

  PrefSetAppPreferences (AppID, 0, 0, &gPrefs, sizeof (gPrefs), true);
  SysCurAppDatabase (&card, &loc);
  if (gPrefs.bits & CMsleep_ON) {
    SysNotifyRegister (card, loc, sysNotifyAppLaunchingEvent, NULL, sysNotifyNormalPriority, NULL);
  } else {
    SysNotifyUnregister (card, loc, sysNotifyAppLaunchingEvent, sysNotifyNormalPriority);
  }
}
// ------------------------------------
// event loop
// ------------------------------------
static void EventLoop(void) {
FormPtr         form;
EventType       event;
UInt16          err;

  do {
    EvtGetEvent (&event, evtWaitForever);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      FrmSetActiveForm (form=FrmInitForm (event.data.frmLoad.formID));
      switch (event.data.frmLoad.formID) {
	case main_form:
	  FrmSetEventHandler (form, (FormEventHandlerPtr) MainFormHandler);
	  break;
      }
    }
    if (FrmDispatchEvent (&event)) continue;
  } while (event.eType != appStopEvent);
  FrmCloseAllForms ();
}
// ------------------------------------
// application entry point
// ------------------------------------
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
Err             error;
UInt16          card;
LocalID         loc;
Char            name[33];

  // notification function
  if (cmd==sysAppLaunchCmdNotify) {
    if (((SysNotifyParamType*)cmdPBP)->notifyType==sysNotifyAppLaunchingEvent) {
      // zjistim, zda se spousti CacheMate
      DmDatabaseInfo (((SysNotifyAppLaunchOrQuitType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->cardNo, 
                      ((SysNotifyAppLaunchOrQuitType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->dbID,
                      name, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
      // povolim/zakazu REM sleep
      SysCurAppDatabase (&card, &loc);
      if (!StrCompare (name, "CacheMate")) {
        SysNotifyRegister (card, loc, hsNotifyRemSleepRequestEvent, NULL, sysNotifyNormalPriority, NULL);
      } else {
        SysNotifyUnregister (card, loc, hsNotifyRemSleepRequestEvent, sysNotifyNormalPriority);
      }
      return 0;
    } else
    if (((SysNotifyParamType*)cmdPBP)->notifyType==hsNotifyRemSleepRequestEvent) {
      // podpora pro REM sleep
      ((SleepEventParamType*)(((SysNotifyParamType*)cmdPBP)->notifyDetailsP))->deferSleep++;
    }
    return 0;
  }
  if (cmd==sysAppLaunchCmdSystemReset) {
    PrefsType lpref;
    UInt16 size=0;
    lpref.bits=CMsleep_ON;
    if (PrefGetAppPreferences (AppID, 0, NULL, &size, true)!=noPreferenceFound) {
      if (size >sizeof (lpref)) size=sizeof (lpref);
      PrefGetAppPreferences (AppID, 0, &lpref, &size, true);
    }
    //MemopadLog ("ML_DEBUG_log\n", "ML reset\n");
    //logovani zpusobi reset!!!
    if (lpref.bits & CMsleep_ON) {
      SysCurAppDatabase (&card, &loc);
      SysNotifyRegister (card, loc, sysNotifyAppLaunchingEvent, NULL, sysNotifyNormalPriority, NULL);
    }
    return 0;
  }
  if (cmd!=sysAppLaunchCmdNormalLaunch)
    return 0;
  // application start-up part
  if ((error=StartApplication ())) {
    FrmAlert (error);
    StopApplication (error);
    return error;
  }
  // display main form
  FrmGotoForm (main_form);
  // event loop
  EventLoop ();
  // application end routine
  StopApplication (0);
  return 0;
}
